unit Unit45;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, StdCtrls, ExtCtrls, TeeProcs, Chart, Mask,
  wwdbedit, Wwdotdot, Wwdbcomb, TeeEdit, TeePreviewPanel;

type
  TForm45 = class(TForm)
    Chart1: TChart;
    Series2: TBarSeries;
    Series3: TBarSeries;
    Series4: TBarSeries;
    Series5: TBarSeries;
    Series6: TBarSeries;
    Series7: TBarSeries;
    Series8: TBarSeries;
    Series9: TBarSeries;
    Series10: TBarSeries;
    Series11: TBarSeries;
    Series12: TBarSeries;
    Series13: TBarSeries;
    Series14: TBarSeries;
    Series15: TBarSeries;
    wwDBComboBox1: TwwDBComboBox;
    ChartEditor1: TChartEditor;
    Button1: TButton;
    Series1: TBarSeries;
    Series16: TBarSeries;
    Series17: TBarSeries;
    Preview: TTeePreviewPanel;
    procedure wwDBComboBox1CloseUp(Sender: TwwDBComboBox; Select: Boolean);
    procedure Button1Click(Sender: TObject);
  private
    procedure SetChartColor(PaletteIndex: integer; Chart: TChart);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form45: TForm45;

implementation

{$R *.dfm}

function ColorDifference(Color1, Color2: TColor): integer;

{ Color difference is determined by the following formula:
from http://www.wat-c.org/tools/CCA/1.1/
(maximum (Red value 1, Red value 2) - minimum (Red value 1, Red value 2)) + (maximum (Green value 1, Green value 2) - minimum (Green value 1, Green value 2)) + (maximum (Blue value 1, Blue value 2) - minimum (Blue value 1, Blue value 2))
}

var
  R1, G1, B1, R2, G2, B2: Byte;
begin
  R1 := GetRValue(Color1);
  G1 := GetGValue(Color1);
  B1 := GetBValue(Color1);

  R2 := GetRValue(Color2);
  G2 := GetGValue(Color2);
  B2 := GetBValue(Color2);

  result := Abs(R1 - R2) + Abs(G1 - G2) + Abs(B1 - B2);
end;

function ColorBrightness(Color: TColor): double;
var
  R, G, B: Byte;
begin
  R := GetRValue(Color);
  G := GetGValue(Color);
  B := GetBValue(Color);

  result := ((R * 299) + (G * 587) + (B * 114)) / 1000;
end;

function GetBrush(index: integer): TBrushStyle;
const
  BrushArray: array[0..6] of TBrushStyle = (bsSolid, bsBDiagonal, bsCross, bsFDiagonal, bsDiagCross, bsHorizontal, bsVertical);
begin
  result := BrushArray[index mod Length(BrushArray)];
end;


function GetFontColor(BackgroundColor: TColor): TColor;
const
  Method = 2;
begin
  // The greater the difference the better the contrast
  if Method = 1 then
    begin
      if Abs(ColorBrightness(BackgroundColor) - ColorBrightness(clWhite)) > Abs(ColorBrightness(BackgroundColor) - ColorBrightness(clBlack)) then
        result := clWhite
      else
        result := clBlack;
    end
  else if Method = 2 then
    begin
      if Abs(ColorDifference(BackgroundColor, clWhite)) > Abs(ColorDifference(BackgroundColor, clBlack)) then
        result := clWhite
      else
        result := clBlack;
    end
end;

procedure TForm45.Button1Click(Sender: TObject);
begin
  ChartEditor1.Execute;
end;

procedure TForm45.SetChartColor(PaletteIndex: integer; Chart: TChart);

const
  PenStyleArray: array[0..4] of TPenStyle = (psSolid, psDash, psDot, psDashDot, psDashDotDot);
  LineSymbolArray: array[0..9] of TSeriesPointerStyle = (psTriangle, psRectangle, psCircle, psDownTriangle, psDiamond, psDiagCross, psStar, psLeftTriangle, psRightTriangle, pscross);
var
  s: integer;

begin
  with Chart1 do
    begin
      Chart1.Legend.Symbol.Squared := false;
      Chart1.Legend.Symbol.WidthUnits := lcsPixels;
      Chart1.Legend.Symbol.Width := 20;
      ColorPalettes.ApplyPalette(Chart1, PaletteIndex);
      for s := 0 to Chart1.SeriesCount - 1 do
        begin
          series[s].ColorEachPoint := false;
          series[s].Brush.Color := ColorPalette[s mod Length(ColorPalette)];
          series[s].Brush.Style := bsBDiagonal; //bsSolid; //GetBrush(s div Length(ColorPalette));
          //if series[s].Brush.Style <> bsSolid then
          //  series[s].Color := GetFontColor(series[s].Brush.Color)
          //else
            series[s].Color := ColorPalette[s mod Length(ColorPalette)];
        end;
    end;
end;

procedure TForm45.wwDBComboBox1CloseUp(Sender: TwwDBComboBox; Select: Boolean);
begin
  if select then
    begin
      SetChartColor(Sender.ItemIndex + 1, Chart1);
      Chart1.Invalidate;
      Chart1.Repaint;
      Preview.Refresh;
    end;
end;

end.

